/* This is the advanced STATUS facility for  SRE-http.
Use NUSTATUS.HTM to invoke this routine.
*/

nustatus:
parse arg  ddir, tempfile, reqstrg,list,verb ,uri,user, ,
          basedir ,workdir,privset,enmadd,transaction,verbose, ,
         servername,host_nickname,homedir
if verb=" " then do
   say "This SRE-http procedure is not meant to be run in standalone mode "
   exit
end  /* Do */

if rxfuncquery('sref_fileread')<>0 then do
  ik=rxfuncadd('sref_fileread','rexxlib','LIB_FILEREAD')
end

if \RxFuncQuery("SockLoadFuncs") then do
 nop      /* already there */
end
else do
   call RxFuncAdd "SockLoadFuncs","rxSock","SockLoadFuncs"
   call SockLoadFuncs
   foo=rxfuncquery('sysloadfuncs')
   if foo=1 then do
     call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
     call SysLoadFuncs
   end
end


list=translate(list, ' ', '+'||'090a0d'x)  /* Whitespace, etc. */

if list='' then list='VU_SERVERSTATS=1'

/* special request: initialize dircache */
if pos('INIT_DIRCACHE=1',upper(list)) then do
  if wordpos('SUPERUSER',upper(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!DIR Cache>'  /* challenge */
       return sref_response('unauth', "You do not have !DIR cache deletion rights ",tempfile,servername)
  end  /* Do */
  call init_dircache
  return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */

/* special request: view recordallfile */
if pos('VU_RECORD=1',upper(list)) then do
  if wordpos('SUPERUSER',upper(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!VURECORD>'  /* challenge */
       return sref_response('unauth', "You do not have VIEW_RECORD rights ",tempfile,servername)
  end  /* Do */
  call vu_record
 return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */


/* special request: view recordallfile */
if pos('VU_COUNTER=1',upper(list))>0 then do
  if wordpos('SUPERUSER',upper(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!VUCOUNTER>'  /* challenge */
       return sref_response('unauth', "You do not have VIEW_COUNTER rights ",tempfile,servername)
  end  /* Do */
  call vu_counter
 return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */

/* special request: view log files */
if pos('VU_LOG=1',upper(list))>0 then do
  if wordpos('SUPERUSER',upper(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!VULOG>'  /* challenge */
       return sref_response('unauth', "You do not have VIEW_LOG rights ",tempfile,servername)
  end  /* Do */
  call vu_log
 return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */

/* special request: view goaudit file */
if pos('VU_AUDIT',upper(list))>0 then do
  if wordpos('SUPERUSER',upper(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!VUAUDIT>'  /* challenge */
       return sref_response('unauth', "You do not have VIEW_AUDIT rights ",tempfile,servername)
  end  /* Do */
  call vu_audit
 return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */


/* special request: view srefproxy */
if pos('VIEW_PROXY',upper(list))>0 then do
  if wordpos('SUPERUSER',upper(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!VUAUDIT>'  /* challenge */
       return sref_response('unauth', "You do not have VIEW_AUDIT rights ",tempfile,servername)
  end  /* Do */
  call view_proxy
 return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */



/* special request: view error log file */
if pos('VU_ERRORLOG',upper(list)) then do
  if wordpos('SUPERUSER',upper(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!VUERRORLOG>'  /* challenge */
       return sref_response('unauth', "You do not have VIEW_ERROR_LOG rights ",tempfile,servername)
  end  /* Do */
  call vu_errorlog
 return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */


/* special request: save goaudit file */
if pos('SAVE_AUDIT',upper(list)) then do
  if wordpos('SUPERUSER',upper(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!SAVEAUDIT>'  /* challenge */
       return sref_response('unauth', "You do not have SAVE_AUDIT rights ",tempfile,servername)
  end  /* Do */
  call save_audit
 return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */

/* special request: do goserve control command */
if pos('DO_CONTROL',upper(list)) then do
  if wordpos('SUPERUSER',upper(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!CONTROL>'  /* challenge */
       return sref_response('unauth', "You do not have CONTROL rights ",tempfile,servername)
  end  /* Do */
  call do_control
 return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */

/* special request:set goserve parameter */
if pos('DO_SET',upper(list)) then do
  if wordpos('SUPERUSER',upper(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!SET>'  /* challenge */
       return sref_response('unauth', "You do not have SET rights ",tempfile,servername)
  end  /* Do */
  call do_set
 return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */


/* special request: querys goserve parmeter */
if pos('DO_QUERY',upper(list)) then do
  if wordpos('SUPERUSER',upper(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!QUERY>'  /* challenge */
       return sref_response('unauth', "You do not have QUERY rights ",tempfile,servername)
  end  /* Do */
  call do_query
 return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */



/* special request: mail a note to someone */
if pos('REMAIL_IT',upper(list)) then do
  if wordpos('SUPERUSER',upper(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!MAIL>'  /* challenge */
       return sref_response('unauth', "You do not have MAIL rights ",tempfile,servername)
  end  /* Do */
  call do_remail
 return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */


if pos('VU_ARGS=1',upper(list)) then do  /* any one can look */
   call vu_args
   return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */

if pos('VU_IP=1',upper(list)) then do  /* any one can look */
   call vu_ip
   return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */

if pos('VU_CSINFO=1',upper(list)) then do  /* any one can look */
   call vu_csinfo
   return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */


if pos('VU_SERVERSTATS=1',upper(list)) then do  /* any one can look */
   call vu_serverstats
   return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */


if pos('VU_NETSTATS=1',upper(list)) then do  /* any one can look */
  if wordpos('SUPERUSER',upper(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!VUNETSTATS>'  /* challenge */
       return sref_response('unauth', "You do not have VIEW_NETSTATS rights ",tempfile,servername)
  end  /* Do */
   call vu_netstats
   return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */






string  'Advanced Status Request: action not supported.'
return '200 46'


/*********************************/
/* server and client info */
vu_csinfo:

   call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

    call lineout tempfile, "<html><head><title>Client and Server Information</title>"
    call lineout tempfile, "</head><body>"

    call lineout tempfile,' <h3> Some Client &amp; Server Info </h3> '

   caddr=extract('CLIENTADDR')
   if value('SREF_NODNS',,'os2environment')=1 then
      cname=caddr
   else
      cname=clientname()
   ssoft=server()
   sname=servername

  if verify(server,'1234567890.')>0 then do  
      rc=sockgethostbyname(strip(servername), "serv.0")   
  end   
  else do  
    serv.0addr=strip(servername)  
   end 
   saddr=serv.0addr
/*    saddr=extract('SERVERADDR') */

   sport=extract('SERVERPORT')

   call lineout tempfile,' <ul> '
   call lineout tempfile,' <li> Client ip address:  <code>' caddr '</code>'
   call lineout tempfile,' <li> Client name:  <code>' cname '</code>'
   call lineout tempfile,' <li> Server ip address: <code>' saddr '</code>'
   call lineout tempfile,' <li> Server port:  <code>' sport '</code>'

   call lineout tempfile,' <li> Server name:  <code>' sname '</code>'
   call lineout tempfile, ' <li> Server software:  <code>' ssoft '</code>'
  aver=sref_version()
   call lineout tempfile,' <li>  Filter version: <code> ' aver ' </code>'
  parse var privset privset1 ',' privset2
   call lineout tempfile,' <li> Your privileges are: <tt> ' privset1 ' </tt>'
   if privset2<>'' then call lineout tempfile,'<em>(with '||words(privset2)||' secret privileges )</em>'
   call lineout tempfile,' </ul> '


/* review cache etnries */
foo=strip(get_value('tempdata_dir'),'t','\')
call lineout tempfile,'<h3> Cache status (in ' foo ') </h3> '
dshs=foo||'\_*.DSH'
oo=sysfiletree(dshs,fred,'FO')
call lineout tempfile,' # of files in the <EM>!DIR cache </EM>= ' fred.0
aport=extract('serverport')
cshs=foo||'\_*.'||aport
oo=sysfiletree(cshs,fred,'FO')
call lineout tempfile,'<br> # of files in the <EM>SSI-Cache files </EM> = ' fred.0 '<br>'

/* check status of daemons */
dolist='ACCESS ALIAS POSTF PUBURL SREPROXY  SREALM  USER VIRTUAL '
call lineout tempfile,'<h3>Daemon status:</h3><ul>'
foo=value('SREF_REDO',,'os2environment')
if foo<>0 then
   call lineout tempfile,'<li>ReSet flag: active '
else
   call lineout tempfile,'<li>ReSet flag: inactive'

do mm=1 to words(dolist)
   aw=strip(word(dolist,mm))
   aw2='SREF_'||aw||'_BAD'
   aw3=value(aw2,,'os2environment')
   select
    when aw3=1 then
       call lineout tempfile,'<li>'aw ': not available (will be restarted) '
    when aw3=0 then
       call lineout tempfile,'<li>'aw ': okay '
    otherwise
       call lineout tempfile,'<li>'aw ': not started '
   end
   
end /* do */
call lineout tempfile,'</ul>'

call lineout tempfile,'</body></html> '
call lineout tempfile
oof=dosdir(tempfile,'s')
return 1

/*********************************/
/* server stats -- using goremote code  */
vu_netstats:
call lineout tempfile,'<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
call lineout tempfile,'<html><head>'
call lineout tempfile,'<title>Socket statistics</title></head><body>'
call lineout tempfile,'<h2>Current socket-connections:'servername'</h2><hr>'
call lineout tempfile,' The following are generated with a NETSTAT -s <p>'
call lineout tempfile,'<pre>'

do queued(); pull . ; end                   /* flush */
address cmd 'Netstat -s  | rxqueue '
do  queued()
      parse pull aresult                      /* get result */
      call lineout tempfile,aresult
end
call lineout tempfile,'</pre></body></html>'


call lineout tempfile

oof=dosdir(tempfile,'s')
return 1

 





/*********************************/
/* server stats -- using goremote code  */
vu_serverstats:
call lineout tempfile,'<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
call lineout tempfile,'<html><head>'
call lineout tempfile,'<title>Server statistics</title></head><body>'
call lineout tempfile,'<h2>Server statistics</h2><hr>'
call lineout tempfile,'<dd><p>'
/* aa=servername() */
call lineout tempfile,'Server name: <strong>'servername'</strong> <br>'

  if verify(server,'1234567890.')>0 then do  
      rc=sockgethostbyname(strip(servername), "serv.0")   
  end   
  else do  
    serv.0addr=strip(servername)  
   end 
   aa=serv.0addr

/*  aa=extract('serveraddr')  */

call lineout tempfile,'Server address: 'aa' <br>'
aa=extract('serverport')
call lineout tempfile,'Server port: 'aa' <br>'
foo=value('SREF_PREFIX',,'os2environment')
if foo<>'' then
    aa='HTTP/1.1'
else
  aa=extract('serverprotocol')
call lineout tempfile,'Server protocol: 'aa' <br>'
call lineout tempfile,'<p>'

aa=extract('transactions')
call lineout tempfile,'Transactions: 'aa' <br>'
requests=extract('requests')
call lineout tempfile,'Requests: 'requests' <br>'
aa=extract('errors')
call lineout tempfile,'Errors: 'aa' <br>'
aa=extract('limits')
call lineout tempfile,'Limits exceeded: 'aa' <br>'
bytessent=extract('bytessenttotal')
call lineout tempfile,'Bytes sent: 'bytessent' <br>'
aa=extract('bytesreadtotal')
call lineout tempfile,'Bytes received: 'aa' <br>'
aa=extract('clients'); aa2=extract('peakclients')
call lineout tempfile,'Clients: 'aa'  [peak 'aa2'] <br>'
aa=extract('responsetime'); aa2=extract('responseover')
call lineout tempfile,'Response time: 'aa'  [average over 'aa2'] <br>'
aa=extract('readwaittime')
call lineout tempfile,'Read wait time: 'aa'  [average] <br>'

call lineout tempfile,'<p>'
aa=extract('limitclients')
call lineout tempfile,'Client limit: ' aa ' <br>'
aa=extract('limittimetotal');aa2=extract('limittimeinactive');
call lineout tempfile,'Watchdog timeout: ' aa 's [or ' aa2 's idle] <br>'
aa=extract('limitstartwait')
call lineout tempfile,'Startup wait timeout: 'aa' <br>'
aa=extract('limittimewait')
call lineout tempfile,'Connection maintain time: 'aa' <br>'

aa=extract('limitheader')
call lineout tempfile,'Read header limit: ' aa 'kB <br>'
aa=extract('limitbody')

call lineout tempfile,'Read body limit: 'aa'kB <br>'

aa=servername()
call lineout tempfile,'Server name: ' aa ' <br>'
aa=extract('gmtoffset')
call lineout tempfile,'Offset from GMT: 'aa' <br>'

call lineout tempfile,'<p>'
aa=extract('lastsecond')
call lineout tempfile,aa' now <br>'
aa=extract('lastidle')
call lineout tempfile,aa'   last return to idle <br>'
aa=extract('lastreset')
call lineout tempfile,aa '  last reset all <br>'
aa=extract('laststart');aa2=server()
call lineout tempfile,aa ' ' aa2 ' started'


call lineout tempfile,' <br>'
oy=value('SREF_PROXY',,'os2environment')
if oy=1 then do
 /* some stats */
   spbytes=value('SREF_PROXY_BYTES',,'os2environment')
   sphits=value('SREF_PROXY_HITS',,'os2environment')

  if spbytes='' then spbytes=0; if sphits='' then sphits=0

   spbytes2=value('SREF_PROXY_BYTES2',,'os2environment')
   sphits2=value('SREF_PROXY_HITS2',,'os2environment')
  if spbytes2='' then spbytes2=0; if sphits2='' then sphits2=0


   pctbytes=format(100*spbytes/bytessent,4,2)
   pcthits=format(100*sphits/requests,4,2)
 
   pctbytes2=format(100*spbytes2/bytessent,4,2)
   pcthits2=format(100*sphits2/requests,4,2)


   call lineout tempfile,'<p> '
   call lineout tempfile,'<table><tr align="RIGHT"><td colspan=4 align="center"><u>Statistics</u></td></tr> '
   call lineout tempfile,'<tr> <th> </th> <th>Sent by SREPROXY</th><th></th> <th>Sent by SREFILTR </th> <th>GoServe Total</th></tr>'
   call lineout tempfile,'<tr align="RIGHT"><td align="LEFT"> Bytes </td> <td>'spbytes '('pctbytes '%)</td>'
   call lineout tempfile,'<td> </td>'
   call lineout tempfile,      '<td>'spbytes2 '('pctbytes2 '%)</td>'
   call lineout tempfile,'    <td>'bytessent'</td>'
   call lineout tempfile,'<tr align="RIGHT"><td align="LEFT"> Hits </td> <td>'sphits '('pcthits '%)</td>'
   call lineout tempfile,'<td> </td>'
   call lineout tempfile,      '<td>'sphits2 '('pcthits2 '%)</td>'
   call lineout tempfile,'    <td>'requests'</td>'
   call lineout tempfile,'</table>'

 
end  /* Do */


call lineout tempfile,'</dl> '

call lineout tempfile,'<br> <em>SuperUsers only:</em> <a href="/Nustatus.cmd?vu_netstats=1">View some socket statitistics </a> <br>'

call lineout tempfile,'</body></html>'


call lineout tempfile

oof=dosdir(tempfile,'s')
return 1

 


/*******************************/
/* Mail a note to someone  */
do_remail:

 NOWAY=0
 call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

 call lineout tempfile, "<html><head><title></title>"
 call lineout tempfile, "</head><body>"

/* first "parse" the parameter list, and store in a simple stem variable */
  m=0
  opts.!to=' '
  opts.!from=' '
  opts.!message=' '
  opts.!gateway=' '
  do until list=""
    parse var list opt1 '&' list
    parse var opt1 optname '='  aval
    aval=strip(packur(translate(aval,' ','+')))
    aa=upper('!'||optname)
    opts.aa=aval
  end
  if opts.!to=' ' then do
     call lineout tempfile,' Error: no TO address '
     NOWAY=1
  end
  if opts.!message=' ' then do
       call lineout tempfile,' Error: no message '
       NOWAY=1
  end  /* Do */

  if opts.!from=' ' then do
      if value('SREF_NODNS',,'os2environment')=1 then
          opts.!from=extract('clientaddr')
      else
          opts.!from=clientname()
  end /* do */

  if opts.!gateway=' ' then opts.!gateway=strip(get_value('smtp_gateway'))

   if opts.!gateway=' ' | OPTS.!GATEWAY=0  then do
       call lineout tempfile,' Error: no smtp gateway available '
       NOWAY=1
   end  /* Do */

IF noway=0 then do
  status=SREF_mailit(opts.!to,opts.!message,opts.!gateway,opts.!from)
  if status=0 then do
       call lineout tempfile,' Unable to mail message to ' opts.!to
  end  
  ELSE DO
    call lineout tempfile,length(opts.!message) ' character message sent from ' opts.!from ' to ' opts.!to '(via ' opts.!gateway
  END
END

    call lineout tempfile,'</body></html>'
    call lineout tempfile
    oof=dosdir(tempfile,'s')
    return 1



/*******************************/
/* Use the HOST function  to look up an IP address */
vu_IP:
   call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

    call lineout tempfile, "<html><head><title>Lookup and IP address</title>"
    call lineout tempfile, "</head><body>"

/* first "parse" the parameter list, and store in a simple stem variable */
  m=0
  do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 optname.m '=' optvalue.m
  end
  optname.0=m

/* see if one of the opts is "getip" */
   chkip=0 ;
   do mm=1 to optname.0
      if translate(optname.mm)='GETIP' then do
         chkip=optvalue.mm
         leave
      end
  end

/* if we found a GETIP, and got it's value, then lookit up */
  hostresult='no IP address was requested '
  if chkip<>0 & chkip<>"" then do
/* Note use of the address cmd xxx to call a OS/2 level command  */
    A=RXQUEUE('S','SESSION')    /* SINCE QUEUE MIGHT BE A THREAD'S QUEUE */
    do queued(); pull .; end                   /* flush */
    address cmd '@host' chkip '| rxqueue'     /* execute the command */
    parse pull hostresult                      /* get result */
  end
  call lineout tempfile,' <h3> Look up address </h3> '
  call lineout tempfile,' <pre> ' hostresult ' </pre>'
  call lineout tempfile,'</body></html>'
  call lineout tempfile
  oof=dosdir(tempfile,'s')
  return 1


/**************************/
/* view the arguments sent to a ssp (add-on) */
vu_args:

        call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

        call lineout tempfile, "<html><head><title>Arguments sent to SRE-http addons</title>"
        call lineout tempfile, "</head><body>"

        call lineout tempfile,' <h3>The following arguments were recieved by this advanced status facility </h3> '

        call lineout tempfile,' <dl> '

        call lineout tempfile,' <dt>  DDIR = <code>' ddir '</code> '
        call lineout tempfile,' <dd>  The "data directory" (where your HTML documents should be) '
        call lineout tempfile,' <dt>  TEMPFILE = <code>' tempfile ' </code> '
        call lineout tempfile,' <dd> The "temporary file" (used to build this response)'

        call lineout tempfile,' <dt>  ACTION = <code>' reqstrg ' </code> '
        call lineout tempfile,' <dd>  The  <b>action</b> portion of the request selector'


        call lineout tempfile,' <dt>  LIST = <code>' list ' </code> '
        call lineout tempfile,' <dd> The <b>parameters</b>: '
        call lineout tempfile, '<br> ... if POST method, from the "body" of the request '
        call lineout tempfile,' <br> ... if GET method ,  from after the "?" in the request selector.  '

        call lineout tempfile,' <dt>  VERB = <code>' VERB ' </code> '
        call lineout tempfile,' <dd>  The HTTP method '

        call lineout tempfile,' <dt>  URI = <code>' URI ' </code> '
        call lineout tempfile,' <dd> The full <b>request string</b> '

        call lineout tempfile,' <dt> USER = <code>' user ' </code> '
        call lineout tempfile,' <dd> USERS ip addrees '

        call lineout tempfile,' <dt>  BASEDIR = <code>' basedir ' </code> '
        call lineout tempfile,' <dd> The "working directory" (where SRE-http lives) '

        call lineout tempfile,' <dt>  WORKDIR = <code>' workdir ' </code> '
        call lineout tempfile,' <dd>  Temporary working files area (for <em>user-supplied </em> programs ) '

        call lineout tempfile,' <Dt> Your privileges are: '
        call lineout tempfile,' <DD> <code> ' privset ' </code> '
 
        call lineout tempfile,' <Dt> The host nickname '
        call lineout tempfile,' <DD> <code> ' host_nickname ' </code> '

        call lineout tempfile, '<dt> The ~ (home directory) string '
        call lineout tempfile,' <Dd> <code> ' homedir  ' </code>'

         call lineout tempfile,'</dl>'


/* Read the "header" -- and display the results */
       'READ HEADER VAR FOO '
         call lineout tempfile,' <h3> The Request Header </h3> '

        call lineout tempfile,' <dd> <blockquote> <pre>' foo  '</pre> </blockquote>'

/* all done, write final end-of-html elements */
     call lineout tempfile,'<body> </html>'
     call lineout tempfile

   oof=dosdir(tempfile,'s')
   return 0


/* ------------------------------------------------------- */
/* Special requests ----------------------*/
/* -------------------------------------------------------- */

/* initialize dir cache */
init_dircache:
  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
  call lineout tempfile, "<html><head><title>Initialize !DIR Cache</title>"
  call lineout tempfile, "</head><body>"
  call lineout tempfile,' <h2>Initialize !DIR Cache</h2>'
  foo=strip(get_value('tempdata_dir'),'t','\')
  dshs=foo||'\_*.DSH'
  oo=sysfiletree(dshs,fred,'FO')
  do mm=1 to fred.0
     foo2=sysfiledelete(fred.mm)
  end /* do */
  iid=foo||'\_DIRLIST.IDX'
  foo=sysfiledelete(iid)
  call lineout tempfile,  ' # of files <b>deleted</b> from the <EM>!DIR cache </EM> = ' fred.0
/* all done, write final end-of-html elements */
  call lineout tempfile,'<body> </html>'
  call lineout tempfile
  oof=dosdir(tempfile,'s')
  return 0


/********************************/
/* SRE-http addon to view the recordall file */   
vu_record:

rfile=get_value('record_all_file')

/* get args */
findme="";sortby="";isdescend=0
do until list=""
    parse var list a1 '&' list
    parse var a1 avar '=' aval; avar=upper(strip(avar)) ; aval=upper(strip(aval))
   if avar="MATCH" then findme=strip(translate(aval,' ','+'||'000d0a09'x))
   if avar="SORT" then sortby=aval
   if avar="DESCEND" then isdescend=aval
end /* do */


  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

  call lineout tempfile, "<html><head><title>SRE-http: View contents of Record All File</title>"
  call lineout tempfile, "</head><body>"
  call lineout tempfile,' <h2>Viewing the contents of the RECORD_ALL_FILE </h2>'

  call lineout tempfile,'Note: the RECORD_ALL_FILE is: ' rfile

  aa=sref_fileread(rfile,eeks,,'E')
  if eeks.0=0 then do
      call lineout tempfile,' Sorry, file is empty or missing '
      signal done
  end

 foo=do_sort(sortby,isdescend,findme,0)
 if  alist.0=0 then do
      call lineout tempfile,' <p>Sorry, no matching entries  '
      signal done
  end
  call lineout tempfile,'<pre> <b> <u>File (or URL)                #hits      Last_hit_date </u></b>'
  do jj=1 to alist.0
      call lineout tempfile,left(alist.jj.!afile,35) ' ' left(alist.jj.!nx,7) ' ' right(alist.jj.!ndate,12)
  end /* do */

 call lineout tempfile,'</pre>'
done:
 call lineout tempfile,'</body></html>'
 call lineout tempfile
 oof=dosdir(tempfile,'s')
 return 0

/* ----------- */
/* sort recordall file by name, date, # hits */
do_sort:procedure expose eeks. alist.
parse arg sortby,isdescend,findme,nodate

dtype='A'
if isdescend=1 | abbrev(upper(isdescend),'Y')=1 then dtype='D'

/*first, cleanup */
mm=0
findme=strip(translate(findme,'/','\'),,'/')

do jj=1 to eeks.0
  if eeks.jj=' ' | abbrev(eeks.jj,';')=1 then iterate
  parse var eeks.jj afile anx adate
  afile=strip(translate(afile,'/','\'),,'/')
   if findme<>"" then do
     okay=sref_wild_match(afile,findme) 
     parse var okay ok1 . ; ok1=strip(ok1)
     if ok1=0 then iterate
  end
  mm=mm+1
  alist.mm.!afile=strip(afile) ; alist.mm.!nx=strip(anx)
  alist.mm.!Ndate=0
  if nodate<>1 then do
    alist.mm.!ndate=dateconv_2(adate,'U','N')
  end
  alist.mm.!origdate=adate

  if datatype(alist.mm.!nx)<>'NUM' then alist.mm.!nx=0
end
alist.0=mm
if mm=0  then return 0

/* now sort */
sortby=upper(strip(sortby))
select
 when sortby="NAME" then do
       do ll=1 to alist.0
            newl.ll=left(alist.ll.!afile,35)||' '||ll
       end /* do */
       stype='I'
 end
 when sortby="HITS" then do
       do ll=1 to alist.0
            newl.ll=left(alist.ll.!nx,35)||' '||ll
       end /* do */
       stype='N'

 end
 when sortby="DATE" then do
       do ll=1 to alist.0
            alist.ll.!ndate=dateconv_2(alist.ll.!ndate,'N','B')
            newl.ll=left(alist.ll.!ndate,35)||' '||ll
       end /* do */
       stype='I'
 end
 otherwise do
     return  0  /* use as is */
 end
end
newl.0=alist.0
yikes=arraysort(newl,1,,1,35,dtype,stype)
do ll=1 to alist.0
            parse var newl.ll .  nth ; nth=strip(nth)
            newl2.ll.!afile=alist.nth.!afile
            newl2.ll.!nx=alist.nth.!nx
            newl2.ll.!ndate=alist.nth.!ndate
            newl2.ll.!oo=alist.nth.!origdate
 end
 do ll=1 to alist.0
            alist.ll.!afile=newl2.ll.!afile
            alist.ll.!nx=newl2.ll.!nx
            alist.ll.!ndate=newl2.ll.!ndate
            if left(strip(alist.ll.!ndate),1)='7' then
                 alist.ll.!ndate=dateconv(alist.ll.!ndate,'b','n')
            alist.ll.!origdate=newl2.ll.!oo
 end /* do */
return 0

/********************************/
/* SRE-http addon to view the counter file */
vu_counter:

rfile=get_value('counter_file')

/* get args */
findme="";sortby="";isdescend=0
do until list=""
    parse var list a1 '&' list
    parse var a1 avar '=' aval; avar=upper(strip(avar)) ; aval=upper(strip(aval))
   if avar="MATCH" then findme=strip(translate(aval,' ','+'||'000d0a09'x))
   if avar="SORT2" then sortby=aval
   if avar="DESCEND" then isdescend=aval
end /* do */
if sortby<>'NAME' & sortby<>'HITS' then sortby='NOSORT'

  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

  call lineout tempfile, "<html><head><title>SRE-http: View contents of Counter File</title>"
  call lineout tempfile, "</head><body>"
  call lineout tempfile,' <h2>Viewing the contents of the COUNTER_FILE </h2>'

  call lineout tempfile,'Note: the COUNTER_FIILE is: ' rfile

  aa=sref_fileread(rfile,eeks,,'E')
  if eeks.0=0 then do
      call lineout tempfile,' Sorry, file is empty or missing '
      signal done
  end

 foo=do_sort(sortby,isdescend,findme,1)
 if  alist.0=0 then do
      call lineout tempfile,' <p>Sorry, no matching entries  '
      signal done
  end
  call lineout tempfile,'<pre> <b> <u>File (or URL)                #hits      Message </u></b>'
  do jj=1 to alist.0
      call lineout tempfile,left(alist.jj.!afile,35) ' ' left(alist.jj.!nx,7) ' ' left(alist.jj.!origdate,32)
  end /* do */

 call lineout tempfile,'</pre>'
done:
 call lineout tempfile,'</body></html>'
 call lineout tempfile
 oof=dosdir(tempfile,'s')
 return 0


/********************************/
/* do a goserve control command */
do_control:


  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

  call lineout tempfile, "<html><head><title>GoServe CONTROL command </title>"
  call lineout tempfile, "</head><body>"
  call lineout tempfile,' <h2>GoServe CONTROL command(s)</h2>'
call lineout tempfile,' <dl> '
do until list=""
  parse var list a1 '&' list
  parse upper var a1 avar '=' aval ;aval=strip(aval)
  if aval="" then iterate
  aval=translate(aval,' ','_')
  if avar="CONTROL" then
      doit=upper(aval)
  else
      iterate
  'CONTROL var fooman ' doit
  call lineout tempfile,'<dt> <b> ' doit '</b> '
  call lineout tempfile,' <dd> <pre> ' fooman ' </pre>'
  fooman=' '
end
call lineout tempfile,' </dl> '

call lineout tempfile, '</body></html> '
call lineout tempfile
foo=sysfiledelete(usefile)
oof=dosdir(oof,'s')
return 1


/********************************/
/* set a  goserve setting */
do_set:

  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

  call lineout tempfile, "<html><head><title>GoServe SET command </title>"
  call lineout tempfile, "</head><body>"
  call lineout tempfile,' <h2>GoServe SET commands</h2>'
call lineout tempfile,' <dl> '
do until list=""
  parse var list a1 '&' list
  parse upper var a1 avar '=' aval ;aval=strip(aval)
  if aval="" then iterate
  if avar="PARAM" then do
      aparam=aval
      iterate
  end  /* Do */
  if avar="VALUE" then do
      avalue=aval
      iterate
  end  /* Do */ 
end
goo='SET '||aparam||' '||avalue
goo

  sresp.21=' Missing keyword in command'
  sresp.22=' Bad keyword in command'
  sresp.23=' Bad value in command'
  sresp.24=' Junk on end of command'
  sresp.26=' Unknown SET/QUERY/EXTRACT item'
  sresp.40=' Bad variable name'
  sresp.41=' Could not set variable'
  sresp.42=' Could not get variable'
  sresp.0=' Success'
  if symbol('SRESP.'||rc)<>'VAR' then
       sisit=' Error.'
  else
       sisit=sresp.rc
  call lineout tempfile,'<dt> <b> ' goo '</b> '
  call lineout tempfile,' <dd> Status= ' sisit ' </pre>'

call lineout tempfile,' </dl> '

call lineout tempfile, '</body></html> '
call lineout tempfile
foo=sysfiledelete(usefile)
oof=dosdir(tempfile,'s')
return 1


/********************************/
/* set a  goserve setting */
do_querY:


  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

  call lineout tempfile, "<html><head><title>GoServe QUERY command </title>"
  call lineout tempfile, "</head><body>"
  call lineout tempfile,' <h2>GoServe QUERY commands</h2>'
call lineout tempfile,' <dl> '
do until list=""
  parse var list a1 '&' list
  parse upper var a1 avar '=' aval2
  if avar<>"QUERY" then iterate
  do until aval2=""
      parse var aval2 aval aval2
     goo=extract(aval)
     call lineout tempfile,'<dt> <b> ' aval '</b> '
     call lineout tempfile,' <dd> 'goo' </pre>'
  end /* do */
end
call lineout tempfile,' </dl> '

call lineout tempfile, '</body></html> '
call lineout tempfile
foo=sysfiledelete(usefile)
oof=dosdir(tempfile,'s')
return 1






/*******************************/
/* save the goaudit.80 file */
save_audit:


sport=extract('SERVERPORT')

  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

  call lineout tempfile, "<html><head><title>Save GoAudit.'||sport||' </title>"
  call lineout tempfile, "</head><body>"
  call lineout tempfile,' <h2>Save GoAudit.'||sport||'</h2>'


savename='GOARCH.'||sport
defname=savename
do until list=""
  parse var list a1 '&' list
  parse upper var a1 avar '=' aval ;aval=strip(aval)
  if aval="" then iterate
  if avar="SAVENAME" then savename=upper(aval)
end
'CONTROL var fooman  MOVEAUDIT '
call lineout tempfile,' Results of MOVEAUDIT command: <code> ' fooman '</code> <p>'
aval=translate(aval,'\','/')
if savename<>defname then do
    fuse=strip(chk_file(basedir,aval))
    if fuse=0 then do
        call lineout tempfile,'  <em>Problem  creating ' savename'.</em><br> <b>Archive file not renamed.</b>'
    end  /* Do */
    else do
       dd=strip(translate(basedir,'\','/'),'t','\')||'\'||defname
        oo=doscopy(dd,strip(fuse),'R')
        if oo<>0 then do
            call lineout tempfile,'  <em>Problem (' oo ')  moving  ' dd ' to ' fuse'</em><br> <b>Archive file not renamed.</b>'
        end
        else do
              call lineout tempfile,'<b>Audit file saved (or appended) to:</b> ' fuse
             call dosdel(defname)
        end  /* Do */
    end  /* Do */
end  /* Do */

arfss:
call lineout tempfile, '</body></html> '
call lineout tempfile
foo=sysfiledelete(usefile)
oof=dosdir(tempfile,'s')
return 1


/********************************/
/* view the goaudit.80 file */
vu_audit:

if rxfuncquery('fileread_rxf')=1 then do
   goti1=RxFuncAdd('Fileread_rxf', 'FILEREXX', 'fileread')
end
if rxfuncquery('fileread_rxf')=0 then do
   call vu_audit2
   return
end
 sport=extract('SERVERPORT')

numlines=1;isdays=0;bolddate=0
do until list=""
  parse var list a1 '&' list
  parse upper var a1 avar '=' aval ;aval=strip(aval)
  if avar="BOLDDATE" then bolddate=1
  if avar='NUMLINES' then  do

/* not implemented yet------
      if  abbrev(aval,'DAYS_')=1 then do
                isdays=1
                aval=substr(aval,6)
      end  /* Do */
---- */
      if aval="FILE" then aval=10000000
      if datatype(aval)='NUM' then
         numlines=max(numlines,aval)
  end  /* Do */
end /* do */
  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

  call lineout tempfile, "<html><head><title>Examine GoAudit.'||sport||' </title>"
  call lineout tempfile, "</head><body>"
  call lineout tempfile,' <h2>Examine GoAudit.'||sport||'</h2>'

usefile=strip(basedir,'t','\')||'\GOAUDIT.'||sport

goaud=stream(usefile,'c','query exists')
if goaud="" then do
   call lineout tempfile,' <h3> Error </h3> '
  call lineout tempfile,' No GOAUDIT.'||sport||' file</b>'
end
isize=dosdir(usefile,'s')

call lineout tempfile, "<br> Examining <em> GoServe's  </em>  GOAUDIT."||sport||' audit-file <em>(# bytes=' isize ')</em>'

tdir=strip(get_value('tempdata_dir'),'t','\')
afoofile=dostempname(tdir||'\$aud????.tmp')
pp='TYPE '||usefile|| ' > ' afoofile
address cmd
pp
address
usefile=afoofile

/* get the file --- use some intelligence about it */
startat=fileget_num(numlines,usefile,isize)

/* --- unimplemented 
if isdays=0 then
 startat=fileget_num(numlines,usefile,isize)
else
 startat=fileget_date2(numlines,usefile,isize)
---- */

if dalines.0=0 then do                  /* error? */
          call lineout tempfile,' <h3> Error </h3>  Could not read: <code> ' usefile '</code> '
          signal arf3
end

if (isize-startat)>500000 then
   call lineout tempfile,'<blockquote> <b>Warning:</b> Only the last 500k bytes of the file will be viewed </blockquote> '

 if numlines >= dalines.0 then do
         call lineout tempfile, '<br><h3> Displaying entire file ( ' dalines.0 ' lines )</h3> '
 end
 else do
        if startat=1 then
           call lineout tempfile, '<br><h3> Displaying last ' numlines ' lines  ( of ' dalines.0 ')</h3> '
         else
           call lineout tempfile, '<br><h3> Displaying last ' numlines ' lines  </h3> '
 end
 call lineout tempfile,'<pre>'
  iwoo=max(1,dalines.0-(numlines-1)); nourls=0
 
  do mm=iwoo to dalines.0
        aline=dalines.mm
        if strip(word(aline,2))='D' then do
           odate=strip(word(aline,4))
           odate=dateconv_2(odate,'s','N')
           call lineout tempfile,dalines.mm '   <b> 'odate '</b>'
        end
        else do
           call lineout tempfile,dalines.mm
        end
   end
   call lineout tempfile,'</pre>'

arf3:
call lineout tempfile, '</body></html> '
call lineout tempfile
foo=sysfiledelete(usefile)
oof=dosdir(tempfile,'s')
return 1

/*************/
/* vu audit, using filerexx procedures */
vu_audit2:
if rxfuncquery('fileopen_rxf')=1 then do
     goti2=RxFuncAdd('Fileopen_rxf', 'FILEREXX', 'fileopen')
end
if rxfuncquery('fileclose_rxf')=1 then do
   goti3=RxFuncAdd('Fileclose_rxf', 'FILEREXX', 'fileclose')
end
if rxfuncquery('fileseek_rxf')=1 then do
   goti3=RxFuncAdd('FileSeek_rxf', 'FILEREXX', 'fileseek')
end
if rxfuncquery('filegetinfo_rxf')=1 then do
   goti3=RxFuncAdd('Filegetinfo_rxf', 'FILEREXX', 'filegetinfo')
end

sport=extract('SERVERPORT')

numlines=1;isdays=0;bolddate=0
do until list=""
  parse var list a1 '&' list
  parse upper var a1 avar '=' aval ;aval=strip(aval)
  if avar="BOLDDATE" then bolddate=1
  if avar='NUMLINES' then  do
      if aval="FILE" then aval=10000000
      if datatype(aval)='NUM' then numlines=max(numlines,aval)
  end  /* Do */
end /* do */

call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

call lineout tempfile, "<html><head><title>Examine GoAudit.'||sport||' </title>"
call lineout tempfile, "</head><body>"
call lineout tempfile,' <h2>Examine GoAudit.'||sport||'</h2>'


usefile=strip(basedir,'t','\')||'\GOAUDIT.'||sport

ahandle=fileopen_rxf(usefile, 'rs', "e")
if ahandle=0 then do
   call lineout tempfile,' <h3> Error </h3> '
   call lineout tempfile,' No file: 'usefile
   signal arf3a
end
isize=filegetinfo_rxf(ahandle,tookie,'SIZE')
isize=tookie.0
ifact=0


agin1a:
ifact=ifact+1
toread=60*ifact*numlines
if toread>500000 & toread<isize then do
   call lineout tempfile,'<blockquote> <b>Warning:</b> Only the last 500k bytes of the file will be viewed </blockquote> '
   toread=500000
end

if ifact=1 then call lineout tempfile, "<br> Examining <em> GoServe's  </em>  GOAUDIT."||sport||' audit-file <em>(# bytes=' isize ')</em>'
if toread > isize then do
   getit=fileread_rxf(ahandle,isize)
end
else do
   ohboy=fileseek_rxf(ahandle,-toread,2)
   getit=fileread_rxf(ahandle,toread)
end  /* Do */

if getit="" then do                  /* error? */
  call lineout tempfile,' <h3> Error </h3>  Could not read: <code> ' usefile '</code> '
  signal arf3a
end

crlf='0d0a'x
ndo=0
if toread<isize then  parse var getit . (crlf) getit  /* throw away partial line */
do until getit=""
   ndo=ndo+1
   parse var getit dalines.ndo (crlf) getit
end /* do */
dalines.0=ndo

select 
   when  toread>499000 then do
        numlines=ndo
   end
   when toread >= isize then numlines=ndo
   when ndo<numlines then signal agin1a
   when ndo > numlines-1 then nop
   otherwise do
      i1=(ndo-numlines)+1 ; ifoo=0
      do i2=i1 to ndo
        ifoo=ifoo+1
        dalines.ifoo=dalines.i2
     end /* do */
     dalines.0=numlines
   end  /* Do */
end

if toread>isize then do
   call lineout tempfile, '<br><h3> Displaying entire file ( ' dalines.0 ' lines  </h3> '
end
else do
   call lineout tempfile, '<br><h3> Displaying last ' numlines ' lines  </h3> '
end
call lineout tempfile,'<pre>'
  iwoo=max(1,dalines.0-(numlines-1)); nourls=0
 
  do mm=iwoo to dalines.0
        aline=dalines.mm
        if strip(word(aline,2))='D' then do
           odate=strip(word(aline,4))
           odate=dateconv_2(odate,'s','N')
           call lineout tempfile,dalines.mm '   <b> 'odate '</b>'
        end
        else do
           call lineout tempfile,dalines.mm
        end
   end
   call lineout tempfile,'</pre>'

arf3a:
call lineout tempfile, '</body></html> '
call lineout tempfile
foo=fileclose_rxf(ahandle)
return 1




/*************/
/* vu errorlog, using filerexx procedures */
vu_errorlog:

oof=0
errorlog=get_value('error_log')
numlines=1
do until list=""
  parse var list a1 '&' list
  parse upper var a1 avar '=' aval ;aval=strip(aval)
  if avar='NUMLINES' then  do
      if aval="FILE" then aval=10000000
      if datatype(aval)='NUM' then numlines=max(numlines,aval)
  end  /* Do */
end /* do */

call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

call lineout tempfile, "<html><head><title>Examine Error Log ' </title>"
call lineout tempfile, "</head><body>"
call lineout tempfile,' <h2>Examine Error Log</h2>'

usefile=' '
if errorlog<>' ' then  usefile=stream(errorlog,'c','query exists')
if usefile=' ' then do
  call lineout tempfile,' <h3> Error </h3>  Could Not Find Error Log File. '
  call lineout tempfile, '</body></html> '
  call lineout tempfile
  oof=dosdir(tempfile,'s')
  return 
end  

isize=dosdir(usefile,'s')

call lineout tempfile, '<br> Examining:  <code> ' usefile '</code><em> (# bytes=' isize ')</em>'

startat=fileget_num(numlines,usefile,isize)
if dalines.0=0 then do                  /* error? */
    call lineout tempfile,' <h3> Error </h3>  Could not read: <code> ' usefile '</code> '
    call lineout tempfile, '</body></html> '
    call lineout tempfile
    oof=dosdir(tempfile,'s')
    return 
end

if (isize-startat)>500000 then
   call lineout tempfile,'<blockquote> <b>Warning:</b> Only the last 500k bytes of the file will be viewed </blockquote> '

if numlines >= dalines.0 then do
         call lineout tempfile, '<br><h3> Displaying entire file ( ' dalines.0 ' lines )</h3> '
end
else do
        if startat=1 then
           call lineout tempfile, '<br><h3> Displaying last ' numlines ' lines  ( of ' dalines.0 ')</h3> '
         else
           call lineout tempfile, '<br><h3> Displaying last ' numlines ' lines  </h3> '
end
call lineout tempfile,'<pre>'
iwoo=max(1,dalines.0-(numlines-1))
do mm=iwoo to dalines.0
         call lineout tempfile,dalines.mm
 end
call lineout tempfile,'</pre>'

call lineout tempfile, '</body></html> '
call lineout tempfile
oof=dosdir(tempfile,'s')
return 1




/********************************/
/* view the log files */
vu_log:

writelogs=get_value('write_logs')
workdata_dir=get_value('workdata_dir')
workdata_dir=strip(workdata_dir,'t','\')

cfgs_dir=value('SRE_CFGS_DIR',,'os2environment')

matchurl='*';matchip='*'
showhead=0 ; removerepeat=0
all_fields=0
clog_fields.=0
wantfile='COMMONLOG'; numlines='WEEK'
do until list=""
   parse var list a1 '&' list
  parse upper var a1 avar '=' aval
  if avar='NUMLINES' then numlines=aval
  if avar="LOGFILE" then wantfile=aval
  if avar="MATCHURL" then matchurl=strip(packur(translate(aval,' ','+')))
  if avar="MATCHIP" then matchip=strip(packur(translate(aval,' ','+')))
  if avar="SHOWHEAD"  then showhead=pos(translate(strip(aval)),'1 YES Y')
  if avar="REMOVEREPEAT" then do
     aval=strip(aval)
     if datatype(aval)='NUM' then removerepeat=aval
  end
  if avar="CLOG_FIELD" then do
      aval=translate(strip(aval))
      if aval='ALL' then do
            all_fields=1
      end /* do */
      else do
         vv='!'||aval
         clog_fields.vv=1
      end
   end
end 

if wantfile='BROWSERLOG' then matchurl='*'
if matchurl=' ' then matchurl="*"
if matchip=' ' then matchip='*'
if matchurl<>'*' then matchurl='/'||strip(matchurl,'l','/')
if length(matchurl)>1 then do
   matchurl=strip(matchurl,'l','/')
end 


  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
  call lineout tempfile, "<html><head><title>Examine Log Files</title>"
  call lineout tempfile, "</head><body>"
  call lineout tempfile,' <h2>Examine Log Files</h2>'

/* get sreflogs.ini from workdir */
afl=workdata_dir||'\SREFLOGS.INI'
logini=stream(afl,'c','query exists')
if logini="" then do
  afl=cfgs_dir||'\SREFLOGS.INI'
  logini=stream(afl,'c','query exists')
  if logini="" then do
    call lineout tempfile,' <h3> Error </h3> '
    call lineout tempfile,' No SREFLOGS.INI file -- can <b>not</b> examine log files! </b>'
  end
end
foo=GET_sreflogs(logini)
mylog=which_logs(host_nickname,wantfile)
if mylog=0 then
  usefile=' '
else
  usefile=word(stuff.!list2,mylog)

adate=date('n')

usefile=stream(usefile,'c','query exists')
if usefile=' ' then do
  call lineout tempfile,' <h3> Error </h3>  Could Not Find Requested Log File: <code> ' wantfile '</code> '
  signal arf
end  /* Do */

isize=dosdir(usefile,'s')

call lineout tempfile, '<br> Current status of WRITE_LOGS = ' writelogs
call lineout tempfile, '<br> Examining:  <code> ' usefile '</code><em> (# bytes=' isize ')</em>'
if matchurl<>'*' & wantfile<>'BROWSERLOG' then
  call lineout tempfile,' <br> Displaying requests that match the <b>request string</b>: <code> ' matchurl '</code> '
if matchip<>'*' & wantfile<>'REFERERLOG' then
  call lineout tempfile,' <br> Displaying requests that match the the <b>client IP name</b>: <code> ' matchip '</code> '



/* it's a time span thing */
bdate=date('b') ;bdate2=0
/* type of lookup */
select
   when numlines='FILE' then do
       isdays=0
       numlines=1000000000000
   end  /* Do */
   when abbrev(numlines,'DAYS_')=1 then do
       numlines=substr(numlines,6)
       if datatype(numlines)<>"NUM" then numlines=1
       else
       isdays=1
   end
   when datatype(numlines)="NUM" then do
        isdays=0
   end  /* Do */
   otherwise do
       numlines=0
       isdays=1
  end  /* Do */
end

if isdays=1 then bdate2=bdate-numlines

/* get the file --- use some intelligence about it */

select
   when  isdays=0 then do
        startat=fileget_num(numlines,usefile,isize)
    end
    otherwise do
         startat=fileget_date(bdate2,usefile,ISIZE)
    end
end
if dalines.0=0 then do                  /* error? */
          call lineout tempfile,' <h3> Error </h3>  Could not read: <code> ' usefile '</code> '
          signal arf
end

if (isize-startat)>500000 then
   call lineout tempfile,'<blockquote> <b>Warning:</b> Only the last 500k bytes of the file will be viewed </blockquote> '


if isdays=0 then do
   if numlines >= dalines.0 then do
         call lineout tempfile, '<br><h3> Displaying entire file ( ' dalines.0 ' lines )</h3> '
   end
   else do
        if startat=1 then
           call lineout tempfile, '<br><h3> Displaying last ' numlines ' lines  ( of ' dalines.0 ')</h3> '
         else
           call lineout tempfile, '<br><h3> Displaying last ' numlines ' lines  </h3> '
   end
   call lineout tempfile,'<pre>'
    iwoo=max(1,dalines.0-(numlines-1)); nourls=0
    do mm=iwoo to dalines.0
        if match_url(dalines.mm,matchurl)=0 | match_ip(dalines.mm,matchip,wantfile)=0 | ,
           isahead(dalines.mm,showhead)=1 then do
             nourls=nourls+1
             iterate
         end  /* Do */
         call do_clogline(dalines.mm)
    end
   call lineout tempfile,'</pre>'
    if nourls>0 then call lineout tempfile, " <b>Note:</b> " nourls "  non-matching entries were <b>not</b> displayed  <p> '"
   signal arf
end

/* isdays=1 : look backwards for first non-matching date */
istart=1
do mm=dalines.0 to 1 by -1
   bdate0=the_dateb(dalines.mm)
   if bdate0<bdate2 then do
        istart=mm
        leave
   end  /* Do */
end
doing=dalines.0-ISTART
if numlines=0 then
   call lineout tempfile,"<h3> Displaying today's entries (" doing " entries)</h3> "
else
   call lineout tempfile,"<h3> Displaying the last " numlines " day's entries (" doing " entries)</h3> "

call lineout tempfile,'<pre>'
nourls=0


repremoved=0
if removerepeat>0 then do       /* remove repetitive entries */
/*DANIELH - DAN [02/Jan/2000:20:31:43 -0500] "GET /samples/srehttp.htm" 200 239580 */
do mm=dalines.0 to (1+istart) by -1
      parse upper var dalines.mm uname . '"' . asel '"' .
      uname=strip(uname); asel=strip(asel)
      do jj=min(dalines.0,mm+removerepeat) to mm+1 by -1  
          if hist.jj=uname'_'asel then do               /* found a match */
              dalines.mm=''                     /* zap this line */
              repremoved=repremoved+1
              leave
          end /* do */
          else do                       /* note this entry */
             idel=mm+removerepeat       
             if (idel<=dalines.0) then drop hist.idel  /* drop old history entry */
             hist.mm=uname'_'asel
          end /* do */
      end               /* scanning "recent forward history" for matches*/
end                     /* scaning lines to display */
end                     /* removerepeat */
do mm=1+istart to dalines.0
      if dalines.mm='' then iterate    /* may have been zapped by removerepeats */
      if match_url(dalines.mm,matchurl)=0 | match_ip(dalines.mm,matchip,wantfile)=0  ,
           | isahead(dalines.mm,showhead)=1 then do
           nourls=nourls+1
          iterate
      end  
       call do_clogline(dalines.mm)

end
call lineout tempfile,'</pre>'
if nourls>0 then call lineout tempfile, " <b>Note:</b> " nourls "  non-matching entries were <b>not</b> displayed  <br> "
if repremoved>0 then call lineout tempfile, repremoved " repeated entries were <b>not</b> displayed  <br> "
call lineout tempfile,'<p>'
signal arf


arf:
call lineout tempfile, '</body></html> '
call lineout tempfile
oof=dosdir(tempfile,'s')
return 1



/******/
/* write selected fields of a commonlog file entry */
do_clogline:procedure expose all_fields clog_fields. tempfile
parse arg cline
 entry.=''
      if all_fields=1 then do
         call lineout tempfile,cline
      end
      else do
        parse var cline ENTRY.!IP ENTRY.!PWD ENTRY.!USER '[' DATETIME ,
          . ']' . '"' . entry.!SEL '"' entry.!STATUS entry.!SIZE
        parse var datetime ENTRY.!DATE ':' entry.!time
        oy1=lastpos('/',entry.!sel)
        if oy1>0 then
          entry.!file=substr(entry.!sel,oy1+1)
        else
          entry.!file=entry.!sel
       parse var entry.!file entry.!file '?' .
       dolist='!IP !USER !DATE !TIME !SEL !FILE !STATUS !SIZE'
       dosize='20 8 0 0 0 15 0 0'
       goo=''
       do mm4=1 to words(dolist)
          aword=strip(translate(word(dolist,mm4)))
          if clog_fields.aword=0 then iterate
          aww=entry.aword
          anum=max(length(aww),strip(word(dosize,mm4)))
          aww=left(aww,anum,' ')
           goo=goo||aww' '
        end
        call lineout tempfile,goo
      end /* do */
return 0

/***************************/
isahead: procedure
parse arg aline,showh
if showh>0 then return 0    /* do NOT suppress HEAD requests */

parse upper var aline . ']' . '"' aa .
if strip(aa)='HEAD' then return 1
return 0



/***************************/
match_url:procedure
parse arg aline,matchurl
parse var aline . '"' oo '"' .
if words(oo)>1 then oo=word(oo,2)
aurl=strip(oo)
if aurl="" then return 1   /* no url, so let it happen */
if matchurl='*' then return 1

 ares=sref_wild_match(aurl,matchurl)
parse var ares astat  .
astat=strip(astat)
if astat=0 then return 0        /* no match */
return 1                /* match */

/***************************/
match_ip:procedure
parse arg aline,matchip,atype


if atype="REFERERLOG" then return 1
if atype="COMMONLOG" then aip=word(aline,1)
if atype="BROWSERLOG" then parse var aline . ']' aip .
aip=strip(aip)
if aip="" then return 1   /* no url, so let it happen */
if matchipl='*' then return 1

ares=sref_wild_match(aip,matchip)
parse var ares astat  .
astat=strip(astat)
if astat=0 then return 0        /* no match */
return 1                /* match */



/***************************/
/* read sreflogs.ini file, return stuff in stuff. */
get_sreflogs:procedure expose stuff. workdata_dir verbose
parse arg afl
/* possible varialbes */
  varlist="COMMONLOG BROWSERLOG REFERERLOG NOOPTIONS NOHTTP NOCODES NOUSER NOURL "
  stemlist="COMMONLOG BROWSERLOG REFERERLOG NOURL "


/* default values */
 stuff.!list='  '; stuff.!list2=' '

/* look in sreflogs.ini for info */
foo=sref_fileread(afl,logsl,,'E')
if logsl.0=0 then return 1       /* use the defaults */

do mm=1 to logsl.0
   aline=strip(upper(logsl.mm))
   if aline="" | abbrev(aline,';')=1 then iterate
   parse upper var aline avar '=' aval
   aval=strip(translate(aval,' ','"'||"'"))
   avar0=strip(avar)
   avar=translate(avar0,' ','.')
   avar1=strip(word(avar,1))
   if wordpos(avar1,'COMMONLOG BROWSERLOG REFERERLOG')>0 then do /* check validity */
     aval=chk_file(workdata_dir,aval)
     if aval<>0 then do
        stuff.!list=stuff.!list||' '||avar0
        stuff.!list2=stuff.!list2||' '||aval
     end
   end
end          /* logsl */

return 1


/************/
/* which log file to use */
which_logs:procedure expose stuff.
parse arg hname,dalog

sport=extract('SERVERPORT')
if hname<>' ' then do
  alist=dalog||'.'||hname||'.'||sport
  alist=alist||' '||dalog||'.'||hname||' '||dalog
end
else do
    alist=dalog||'.'||sport||' '||dalog
end
alist=upper(alist)
do li=1 to words(alist)
   a1=strip(word(alist,li))
   iio=wordpos(a1,stuff.!list)
    if iio>0 then do
       return iio
    end
end
return 0

/**************/
/* read date from log file, return as julian */
the_dateb:procedure
parse arg aline
   parse var aline . '[' adate ':' .
   adate=translate(adate,' ','/')
   bdate0=dateconv_2(adate,'n','b')
   return bdate0

/***************/
/* numric "numlines" read */
fileget_num:procedure  expose dalines.
parse arg numlines,usefile,isize
iter=1
goofer: nop             /* jump here if didn't read enough */

startat=max(1,isize-(iter*100*numlines))
IF STARTAT=1 then do
   woo=sref_fileread(usefile,dalines,,'E')
   return 1
end

woo=sref_fileread(usefile,dalines,,'E',,startat)

if (dalines.0<numlines) & (startat >1) & ((isize-startat)<500000)  then do
        iter=iter+1
        signal goofer
end  /* Do */

return startat

/***************/
/* numric "numlines" read */
fileget_date:procedure  expose dalines.
parse arg thedate,usefile,isize


/* if < 100k, just read the whole thing in*/
if isize<100000 then do
   woo=sref_fileread(usefile,dalines,,'E')
   return 1
end

/* else, search from back of file till you get old enouth entry */
iter=1
goofer2: nop             /* jump here if didn't read enough */

startat=max(1,isize-(iter*35000))
IF STARTAT=1 then DO
   woo=sref_fileread(usefile,dalines,,'E')
   return 1
end

woo=sref_fileread(usefile,dalines,5,'E',,startat)
if dalines.0<2 then return 0            /*ERROR */
DATEB=THE_DATEB(DALINES.2)
if (daTEB>THEDATE) & (startat >1) & ((isize-startat)<500000)  then do
        iter=iter+1
        signal goofer2
end  /* Do */

woo=sref_fileread(usefile,dalines,,'E',,startat)   /* GET FROM HERE */

RETURN STARTAT


/* ----------- */
/* get environment value. Typically, look for host-specific
value first, and then look for generic value (if no host given,
skip host-specific lookup )
vname: variable to lookup
hname0: Special instructions:
  hname0=0 -- do not look under host nickname
  hname0=1 -- do not look under default
 */
/* ------------ */
get_value: procedure expose enmadd host_nickname
parse upper arg vname,hname0
if hname0=0 then
        hname=' '
else
    hname=strip(host_nickname)

vname=strip(vname) ;
if hname<>' ' then do
   booger=strip(enmadd||vname||'.'||hname)
   aval=value(booger,,'os2environment')
   if aval<>' ' | hname0=1 Then
        return aval
end
aval=value(enmadd||vname,,'os2environment')
return aval


/************/
/* check for valid file name, and return it. Return 0 if no good */
chk_file:procedure
parse arg workdir, aval
  fn1=translate(strip(upper(aval)),'\','/')  /* the filename */
  fn1=strip(translate(fn1,' ',"'"||'"'))
  if abbrev(fn1,'\')=1 | pos(':',fn1)>0 then
       fuse=fn1
   else
       fuse=workdir||'\'||fn1
   foo=strip(filespec('d',fuse)||filespec('p',fuse),'t','\')
   if right(foo,1)=':' then foo=foo||'\'

   if dosisdir(foo)=0 then return 0  /* no such dir--error, so ignore */
   if pos('?',fuse)>0 then
      return systempfilename(fuse)
   else
       return fuse

/************/
/* view sreproxy stuff */

view_proxy:

call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

call lineout tempfile, "<html><head><title>Examine SREPROXY cache  </title>"
call lineout tempfile, "</head><body>"
call lineout tempfile,' <h2>Examine SREPROXY cache</h2>'

arange=''
parse var list 'RANGE=' arange '&' .


aa=value('SREF_PROXY',,'os2environment')
if aa<>1 then do
    call lineout tempfile,'<b> Sorry, SREPROXY not enabled </b></body</Html> '
    return 1
end

mytid=dostid()
mysem='\SEM32\'||enmadd||"t"||mytid
myqueue=enmadd||'t'||mytid
reqnum=extract('request')

goober='SREF_SREPROXY'
a=rxqueue('s',goober)
queue  reqnum','myqueue','mysem',SHOW,'arange
a=eventsem_reset(mysem)
dothread='\SEM32\SREF_SREPROXY'
a=eventsem_post(dothread)

a=eventsem_wait(mysem)
if a<>0 then do
   sss=sref_error(' A Fatal Semaphore failure in NUSTATUS 'a,1)
   exit 0
end
a=rxqueue('s',myqueue)
parse pull aline
PARSE VAR ALINE idnum ',' aline

idnum=strip(translate(idnum,' ','000d0a'x));TRANSACTION=STRIP(TRANSACTION)
if idnum<>reqnum then  do /*wierd error: got someone else's message, give up */
      say ' Read odd id from sreproxy queue :' idnum0 ',' idnum
      'STRING Error in server (NUSTATUS SREPROXY QUERY) '
      exit
end

aline=strip(aline)
call lineout tempfile,'<PRE>'aline'</pre> </body></html>'
call lineout tempfile
return 1


/******************/
/* call rexxlib date conversion, but check y2k first */
dateconv_2:procedure
parse upper arg aval,t1,t2
select 
 when t1='O' | t1='U' | t1='E' then do
   if t1='O' then      parse var aval yy '/' mo '/' dd
   if t1='U' then     parse var aval mo '/' dd '/' yy
   if t1='E' then     parse var aval dd '/' mo '/' yy
   if yy<78 then 
       yy=2000+yy 
   else
      yy=yy+1900
    yip=strip(yy)||strip(mo)||strip(dd)
    adatef=dateconv(yip,'S',t2)
  end
  otherwise do
    adatef=dateconv(aval,t1,t2)
  end
end
return adatef

